# $Id: Generator.pm 29024 2009-10-16 13:01:37Z wsl $
# $URL: https://infix.uvt.nl/its-id/trunk/sources/aselect-perl/lib/Aselect/Generator.pm $

use utf8;
use strict;
use warnings FATAL => 'all';

package Aselect::Generator;

use Xyzzy::Generator -Base;

use Crypt::OpenSSL::Random;
use IO::File;

sub db_name { 'aselect' }
sub db_user { 'aselect' }

sub random_bytes {
	our $seed;
	unless(defined $seed) {
		my $cfg = $self->cfg;

		my $randomdev = $cfg->randomdev || '/dev/urandom';

		my $fh = new IO::File($randomdev, '<:raw')
			or die "$randomdev: $!\n";

		my $ret = $fh->read($seed, 16)
			or die "$randomdev: $!\n";

		$fh->close;

		Crypt::OpenSSL::Random::random_seed($seed);
	}
	return Crypt::OpenSSL::Random::random_bytes(@_);
}

sub random_hexbytes {
	my $hex = unpack('H*', my $bytes = $self->random_bytes(@_));
	$hex =~ tr/a-z/A-Z/;
	return wantarray ? ($hex, $bytes) : $hex;
}
